ServerEvents.recipes((event) => {
  
  // =========================================
  // Misc Stuff
  // =========================================

  // Vanilla Beehive
  event
    .shaped("minecraft:beehive", [
      "AAA", 
      "BCB", 
      "AAA"
    ], 
    {
      A: "the_bumblezone:beehive_beeswax",
      B: "the_bumblezone:porous_honeycomb_block",
      C: "the_bumblezone:empty_honeycomb_brood_block",
    })
    .id("minecraft:beehive");

  // Cog Block
  event
    .shaped("6x supplementaries:cog_block", [
      "ABA", 
      "BCB", 
      "ABA"
    ], 
    {
      A: "#forge:ingots/copper",
      B: "#forge:gears/copper",
      C: "#forge:storage_blocks/redstone",
    })
    .id("supplementaries:cog_block");

  //Regions Unexplored Blackstone Cluster (fix recipe conflict with polished blackstone)
  event
    .shapeless("regions_unexplored:blackstone_cluster", [
      "minecraft:blackstone",
      "minecraft:blackstone",
    ])
    .id("regions_unexplored:blackstone_cluster");

  // Supplementaries Antique Ink
  event.recipes.create
    .filling("supplementaries:antique_ink", [
      Fluid.of("create_enchantment_industry:ink", 250),
      "minecraft:glass_bottle",
    ])
    .id("supplementaries:antique_ink");

  // Supplementaries Lock Block
  event
    .shapeless("supplementaries:lock_block", [
      "create:andesite_casing",
      "monobank:replacement_lock",
    ])
    .id("supplementaries:lock_block");

  // Supplementaries Key
  event
    .shaped("supplementaries:key", [
      "A ", 
      "BC", 
      "BC"
    ], 
    {
      A: "#forge:gears/gold",
      B: "#forge:rods/blaze",
      C: "#forge:nuggets/gold",
    })
    .id("supplementaries:key");
  
  // Cardboard Box Mod
  event
    .shaped("cardboardbox:crate", [
      "AAA", 
      "A A", 
      "AAA"
    ], 
    {
      A: "create:cardboard"
    })
    .id("cardboardbox:crate");

  // =========================================
  // Dimensional Dungeon Stuff
  // =========================================

  // Block Portal Keyhole
  event
    .shapeless("dimdungeons:block_portal_keyhole", [
      "dimdungeons:block_gilded_portal",
      "minecraft:ender_eye",
      "supplementaries:lock_block",
    ])
    .id("dimdungeons:recipe_block_portal_keyhole");

  // Blank Portal Key
  event
    .shapeless("dimdungeons:item_portal_key", [
      "minecraft:name_tag",
      "supplementaries:key",
    ])
    .id("dimdungeons:recipe_item_blank_key");

  // =========================================
  // Alexs Caves Hazmat Suit Recipes
  // =========================================

  // Hazmat mask
  event
    .shaped("alexscaves:hazmat_mask", [
      "AAA", 
      "ABA"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_helmet",
    })
    .id("alexscaves:hazmat_mask");

  // Hazmat chestplate
  event
    .shaped("alexscaves:hazmat_chestplate", [
      "A A", 
      "ABA", 
      "AAA"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_chestplate",
    })
    .id("alexscaves:hazmat_chestplate");

  // Hazmat leggings
  event
    .shaped("alexscaves:hazmat_leggings", [
      "AAA", 
      "ABA", 
      "A A"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_leggings",
    })
    .id("alexscaves:hazmat_leggings");

  // Hazmat boots
  event
    .shaped("alexscaves:hazmat_boots", [
      "ABA", 
      "A A"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_boots",
    })
    .id("alexscaves:hazmat_boots");

  // Adding back an older Labels recipe
  event
    .shaped("8x labels:label", [
      "AAA", 
      "ABA",
      "AAA"
    ], 
    {
      A: "minecraft:paper",
      B: 'supplementaries:antique_ink',
    })
    .id("labels:label");

  // Final Quest Recipe
  event.recipes.create
    .mechanical_crafting("kubejs:generikb", [
      "ABCDE", 
      "FGHIJ", 
      "KLMNO", 
      "PQRST", 
      "UVWXY"
    ],
    {
      A: 'thermal:beekeeper_helmet',
      B: 'seadwellers:depth_helmet',
      C: 'ad_astra:jet_suit_helmet',
      D: 'alexscaves:hazmat_mask',
      E: 'alexscaves:primordial_helmet',
      F: '#minecards:cards',
      G: 'seadwellers:depth_pickaxe',
      H: 'alexscaves:tremorsaurus_egg',
      I: 'deeperdarker:warden_pickaxe',
      J: '#moa_decor_toys:plushies',
      K: 'naturalist:teddy_bear',
      L: 'alexscaves:radgill_bucket',
      M: 'alexscaves:heart_of_iron',
      N: 'alexscaves:immortal_embryo',
      O: 'starmetal:star_metal',
      P: '#tarotcards:tarot_cards',
      Q: 'rats:ratlantis_pickaxe',
      R: 'alexscaves:darkened_apple',
      S: 'undergarden:forgotten_pickaxe',
      T: 'undergarden:gronglet',
      U: 'ad_astra:moon_desh_ore',
      V: 'ad_astra:mars_ostrum_ore',
      W: 'ad_astra:venus_calorite_ore',
      X: 'ad_astra:glacio_ice_shard_ore',
        Y: 'ad_astra:mercury_iron_ore'
    })
    .id("kubejs:generikb"); 
    
  // Creative Ammo Box
  event.recipes.create
    .mechanical_crafting("scguns:creative_ammo_box", [
      "ABC", 
      "DEF", 
      "GHI", 
      "JKL", 
      "MNM"
    ],
    {
      A: Item.of("minecards:card_emerald", '{Foil:1, Quality:"mint"}').strongNBT(),
      B: Item.of("minecards:card_bell", '{Foil:1, Quality:"mint"}').strongNBT(),
      C: Item.of("minecards:card_villager", '{Foil:1, Quality:"mint"}').strongNBT(),
      D: Item.of("minecards:card_iron_golem", '{Foil:1, Quality:"mint"}').strongNBT(),
      E: Item.of("minecards:card_pillager", '{Foil:1, Quality:"mint"}').strongNBT(),
      F: Item.of("minecards:card_vindicator", '{Foil:1, Quality:"mint"}').strongNBT(),
      G: Item.of("minecards:card_ravager", '{Foil:1, Quality:"mint"}').strongNBT(),
      H: Item.of("minecards:card_evoker", '{Foil:1, Quality:"mint"}').strongNBT(),
      I: Item.of("minecards:card_illusioner", '{Foil:1, Quality:"mint"}').strongNBT(),
      J: Item.of("minecards:card_raid", '{Foil:1, Quality:"mint"}').strongNBT(),
      K: Item.of("minecards:card_village", '{Foil:1, Quality:"mint"}').strongNBT(),
      L: Item.of("minecards:card_woodland_mansion", '{Foil:1, Quality:"mint"}').strongNBT(),
      M: 'scguns:special_ammo_box',
      N: Item.of("minecards:golden_card_set_village_and_pillage", '{Foil:1, Quality:"mint"}').strongNBT(),
    })
    .id("scguns:creative_ammo_box"); 

  // Creative Motor
  event.recipes.create
    .mechanical_crafting("create:creative_motor", [
      "ABCDE", 
      "FGHIJ", 
      "KLMNO", 
      "PQRST", 
      "UVWXY",
      "  Z  "
    ],
    {
      A: Item.of("minecards:card_the_overworld", '{Foil:1, Quality:"mint"}').strongNBT(),
      B: Item.of("minecards:card_grass_block", '{Foil:1, Quality:"mint"}').strongNBT(),
      C: Item.of("minecards:card_stone", '{Foil:1, Quality:"mint"}').strongNBT(),
      D: Item.of("minecards:card_sand", '{Foil:1, Quality:"mint"}').strongNBT(),
      E: Item.of("minecards:card_wood", '{Foil:1, Quality:"mint"}').strongNBT(),
      F: Item.of("minecards:card_copper_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      G: Item.of("minecards:card_coal_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      H: Item.of("minecards:card_iron_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      I: Item.of("minecards:card_gold_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      J: Item.of("minecards:card_emerald_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      K: Item.of("minecards:card_lapis_lazuli_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      L: Item.of("minecards:card_diamond_ore", '{Foil:1, Quality:"mint"}').strongNBT(),
      M: 'create_dd:kinetic_motor',
      N: Item.of("minecards:card_water", '{Foil:1, Quality:"mint"}').strongNBT(),
      O: Item.of("minecards:card_lava", '{Foil:1, Quality:"mint"}').strongNBT(),
      P: Item.of("minecards:card_air", '{Foil:1, Quality:"mint"}').strongNBT(),
      Q: Item.of("minecards:card_crafting_table", '{Foil:1, Quality:"mint"}').strongNBT(),
      R: Item.of("minecards:card_bed", '{Foil:1, Quality:"mint"}').strongNBT(),
      S: Item.of("minecards:card_tnt", '{Foil:1, Quality:"mint"}').strongNBT(),
      T: Item.of("minecards:card_zombie", '{Foil:1, Quality:"mint"}').strongNBT(),
      U: Item.of("minecards:card_skeleton", '{Foil:1, Quality:"mint"}').strongNBT(),
      V: Item.of("minecards:card_spider", '{Foil:1, Quality:"mint"}').strongNBT(),
      W: Item.of("minecards:card_player", '{Foil:1, Quality:"mint"}').strongNBT(),
      X: Item.of("minecards:card_creeper", '{Foil:1, Quality:"mint"}').strongNBT(),
      Y: Item.of("minecards:card_diamond_sword", '{Foil:1, Quality:"mint"}').strongNBT(),
      Z: Item.of("minecards:golden_card_set_overworld", '{Foil:1, Quality:"mint"}').strongNBT()
    })
    .id("create:creative_motor"); 

    // Creative Tank
  event.recipes.create
    .mechanical_crafting("create:creative_fluid_tank", [
      "ABCDE", 
      "FGHIJ", 
      "KLMNO", 
      " PQR ", 
      " STS "
    ],
    {
      A: Item.of("minecards:card_cobblestone", '{Foil:1, Quality:"mint"}').strongNBT(),
      B: Item.of("minecards:card_gravel", '{Foil:1, Quality:"mint"}').strongNBT(),
      C: Item.of("minecards:card_rose", '{Foil:1, Quality:"mint"}').strongNBT(),
      D: Item.of("minecards:card_cyan_flower", '{Foil:1, Quality:"mint"}').strongNBT(),
      E: Item.of("minecards:card_nether_reactor_core", '{Foil:1, Quality:"mint"}').strongNBT(),
      F: Item.of("minecards:card_cow_token", '{Foil:1, Quality:"mint"}').strongNBT(),
      G: Item.of("minecards:card_sheep_token", '{Foil:1, Quality:"mint"}').strongNBT(),
      H: Item.of("minecards:card_zombie_token", '{Foil:1, Quality:"mint"}').strongNBT(),
      I: Item.of("minecards:card_skeleton_token", '{Foil:1, Quality:"mint"}').strongNBT(),
      J: Item.of("minecards:card_creeper_token", '{Foil:1, Quality:"mint"}').strongNBT(),
      K: Item.of("minecards:card_human", '{Foil:1, Quality:"mint"}').strongNBT(),
      L: Item.of("minecards:card_testificate", '{Foil:1, Quality:"mint"}').strongNBT(),
      M: Item.of("minecards:card_brick_pyramid", '{Foil:1, Quality:"mint"}').strongNBT(),
      N: Item.of("minecards:card_feather", '{Foil:1, Quality:"mint"}').strongNBT(),
      O: Item.of("minecards:card_disc_eleven", '{Foil:1, Quality:"mint"}').strongNBT(),
      P: Item.of("minecards:card_herobrine", '{Foil:1, Quality:"mint"}').strongNBT(),
      Q: Item.of("minecards:card_the_far_lands", '{Foil:1, Quality:"mint"}').strongNBT(),
      R: Item.of("minecards:card_enchanted_golden_apple", '{Foil:1, Quality:"mint"}').strongNBT(),
      S: 'create:fluid_tank',
      T: Item.of("minecards:golden_card_set_retro", '{Foil:1, Quality:"mint"}').strongNBT()
    })
    .id("create:creative_fluid_tank");

    // Creative RF Coil
  event.recipes.create
    .mechanical_crafting("thermal:rf_coil_creative_augment", [
      "ABCDEF", 
      "GHIJKL", 
      "MNOPQR", 
      "STUVWX", 
      "YZabcd"
    ],
    {
      A: Item.of("minecards:card_the_nether", '{Foil:1, Quality:"mint"}').strongNBT(),
      B: Item.of("minecards:card_netherrack", '{Foil:1, Quality:"mint"}').strongNBT(),
      C: Item.of("minecards:card_glowstone", '{Foil:1, Quality:"mint"}').strongNBT(),
      D: Item.of("minecards:card_nether_quartz", '{Foil:1, Quality:"mint"}').strongNBT(),
      E: Item.of("minecards:card_nether_wart", '{Foil:1, Quality:"mint"}').strongNBT(),
      F: Item.of("minecards:card_piglin", '{Foil:1, Quality:"mint"}').strongNBT(),
      G: Item.of("minecards:card_zombified_piglin", '{Foil:1, Quality:"mint"}').strongNBT(),
      H: Item.of("minecards:card_ghast", '{Foil:1, Quality:"mint"}').strongNBT(),
      I: Item.of("minecards:card_magma_cube", '{Foil:1, Quality:"mint"}').strongNBT(),
      J: Item.of("minecards:card_blaze", '{Foil:1, Quality:"mint"}').strongNBT(),
      K: Item.of("minecards:card_nether_fortress", '{Foil:1, Quality:"mint"}').strongNBT(),
      L: Item.of("minecards:card_wither", '{Foil:1, Quality:"mint"}').strongNBT(),
      M: Item.of("minecards:golden_card_set_nether", '{Foil:1, Quality:"mint"}').strongNBT(),
      N: 'thermal:rf_coil_augment',
      O: 'thermal:rf_coil_storage_augment',
      P: 'thermal:rf_coil_xfer_augment',
      Q: 'thermal:dynamo_throttle_augment',
      R: Item.of("minecards:golden_card_set_end", '{Foil:1, Quality:"mint"}').strongNBT(),
      S: Item.of("minecards:card_the_end", '{Foil:1, Quality:"mint"}').strongNBT(),
      T: Item.of("minecards:card_endstone", '{Foil:1, Quality:"mint"}').strongNBT(),
      U: Item.of("minecards:card_obsidian", '{Foil:1, Quality:"mint"}').strongNBT(),
      V: Item.of("minecards:card_chorus_plant", '{Foil:1, Quality:"mint"}').strongNBT(),
      W: Item.of("minecards:card_end_crystal", '{Foil:1, Quality:"mint"}').strongNBT(),
      X: Item.of("minecards:card_eye_of_ender", '{Foil:1, Quality:"mint"}').strongNBT(),
      Y: Item.of("minecards:card_elytra", '{Foil:1, Quality:"mint"}').strongNBT(),
      Z: Item.of("minecards:card_stronghold", '{Foil:1, Quality:"mint"}').strongNBT(),
      a: Item.of("minecards:card_end_city", '{Foil:1, Quality:"mint"}').strongNBT(),
      b: Item.of("minecards:card_enderman", '{Foil:1, Quality:"mint"}').strongNBT(),
      c: Item.of("minecards:card_shulker", '{Foil:1, Quality:"mint"}').strongNBT(),
      d: Item.of("minecards:card_ender_dragon", '{Foil:1, Quality:"mint"}').strongNBT()
    })
    .id("thermal:rf_coil_creative_augment"); 

    // Creative RS Storage Disk
  event.recipes.create
    .mechanical_crafting("refinedstorage:creative_storage_disk", [
      "ABCDEF", 
      "GHIJKL", 
      "MNOPQR", 
      "STUVWX", 
      "YZabcd"
    ],
    {
      A: Item.of("minecards:card_squid", '{Foil:1, Quality:"mint"}').strongNBT(),
      B: Item.of("minecards:card_dolphin", '{Foil:1, Quality:"mint"}').strongNBT(),
      C: Item.of("minecards:card_turtle", '{Foil:1, Quality:"mint"}').strongNBT(),
      D: Item.of("minecards:card_coral", '{Foil:1, Quality:"mint"}').strongNBT(),
      E: Item.of("minecards:card_salmon", '{Foil:1, Quality:"mint"}').strongNBT(),
      F: Item.of("minecards:card_pufferfish", '{Foil:1, Quality:"mint"}').strongNBT(),
      G: Item.of("minecards:card_guardian", '{Foil:1, Quality:"mint"}').strongNBT(),
      H: Item.of("minecards:card_elder_guardian", '{Foil:1, Quality:"mint"}').strongNBT(),
      I: Item.of("minecards:card_fishing_rod", '{Foil:1, Quality:"mint"}').strongNBT(),
      J: Item.of("minecards:card_kelp", '{Foil:1, Quality:"mint"}').strongNBT(),
      K: Item.of("minecards:card_sponge", '{Foil:1, Quality:"mint"}').strongNBT(),
      L: Item.of("minecards:card_ocean_monument", '{Foil:1, Quality:"mint"}').strongNBT(),
      M: Item.of("minecards:golden_card_set_aquatic", '{Foil:1, Quality:"mint"}').strongNBT(),
      N: 'refinedstorage:1k_storage_disk',
      O: 'refinedstorage:4k_storage_disk',
      P: 'refinedstorage:16k_storage_disk',
      Q: 'refinedstorage:64k_storage_disk',
      R: Item.of("minecards:golden_card_set_deep_and_dark", '{Foil:1, Quality:"mint"}').strongNBT(),
      S: Item.of("minecards:card_deepslate", '{Foil:1, Quality:"mint"}').strongNBT(),
      T: Item.of("minecards:card_glow_berry", '{Foil:1, Quality:"mint"}').strongNBT(),
      U: Item.of("minecards:card_dripleaf", '{Foil:1, Quality:"mint"}').strongNBT(),
      V: Item.of("minecards:card_sculk", '{Foil:1, Quality:"mint"}').strongNBT(),
      W: Item.of("minecards:card_glow_squid", '{Foil:1, Quality:"mint"}').strongNBT(),
      X: Item.of("minecards:card_sculk_shrieker", '{Foil:1, Quality:"mint"}').strongNBT(),
      Y: Item.of("minecards:card_echo_shard", '{Foil:1, Quality:"mint"}').strongNBT(),
      Z: Item.of("minecards:card_lush_caves", '{Foil:1, Quality:"mint"}').strongNBT(),
      a: Item.of("minecards:card_dripstone_caves", '{Foil:1, Quality:"mint"}').strongNBT(),
      b: Item.of("minecards:card_deep_dark", '{Foil:1, Quality:"mint"}').strongNBT(),
      c: Item.of("minecards:card_warden", '{Foil:1, Quality:"mint"}').strongNBT(),
      d: Item.of("minecards:card_ancient_city", '{Foil:1, Quality:"mint"}').strongNBT()
    })
    .id("refinedstorage:creative_storage_disk"); 

});